// Decompiled by Jad v1.5.8f. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ActiveContours.java

import java.awt.*;
import java.awt.event.*;
import java.awt.image.PixelGrabber;
import java.io.PrintStream;

import java.util.Vector;

public class ActiveContours extends Canvas
{
    class KeyClicker extends KeyAdapter
    {

        public void keyPressed(KeyEvent e)
        {
            if(drawContour && ptsMoved != 0)
            {
                char c = e.getKeyChar();
                if(c == '\n')
                    iterateSnake(3, 100);
                else
                    //ptsMoved = snake.moveSnake(3);
					iterateSnake(3, 1);
                contour = snake.getContour();
                drawOval = false;
                repaint();
            }
        }

        KeyClicker()
        {
        }
    }

    class MouseMover extends MouseMotionAdapter
    {

        public void mouseDragged(MouseEvent e)
        {
            if(mouseDn)
            {
                ovalWidth = e.getX() - initX;
                ovalHeight = e.getY() - initY;
                drawOval = true;
                drawContour = false;
                repaint();
            }
        }

        MouseMover()
        {
        }
    }

    class MouseClicker extends MouseAdapter
    {

        public void mousePressed(MouseEvent e)
        {
            mouseDn = true;
            initX = e.getX();
            initY = e.getY();
            ovalWidth = 0;
            ovalHeight = 0;
            drawOval = false;
            drawContour = false;
        }

        public void mouseReleased(MouseEvent e)
        {
            if(mouseDn)
            {
				contourHistory.clear();

                mouseDn = false;
                ovalWidth = e.getX() - initX;
                ovalHeight = e.getY() - initY;
                if(ovalWidth < 0)
                {
                    initX+= ovalWidth;
                    ovalWidth = -ovalWidth;
                }
                if(ovalHeight < 0)
                {
                    initY+= ovalHeight;
                    ovalHeight = -ovalHeight;
                }
                drawContour = snake.getContourFromOval(initX, initY, ovalWidth, ovalHeight, pointSpacing);
                contourInit = drawContour;
                if(drawContour)
                    contour = snake.getContour();
                drawOval = false;
                ptsMoved = -1;
                repaint();
            }
        }

        public void mouseExited(MouseEvent e)
        {
            if(drawOval || mouseDn)
            {
                drawOval = false;
                repaint();
            }
        }

        public void mouseEntered(MouseEvent e)
        {
            if(parameterChange && contourInit)
            {
                requestFocus();
                parameterChange = false;
                mouseDn = false;
                drawContour = snake.getContourFromOval(initX, initY, ovalWidth, ovalHeight, pointSpacing);
                if(drawContour)
                    contour = snake.getContour();
                drawOval = false;
                ptsMoved = -1;
                repaint();
            }
        }

        MouseClicker()
        {
        }
    }


    public ActiveContours(Image img, Container parent, int width, int height)
    {
        trueSizeKnown = false;
        initX = 0;
        initY = 0;
        ovalWidth = 0;
        ovalHeight = 0;
        ptsMoved = -1;
        drawOval = false;
        drawContour = false;
        mouseDn = false;
        parameterChange = false;
        contourInit = false;
        image = img;
        w = width;
        h = height;
        addMouseListener(new MouseClicker());
        addMouseMotionListener(new MouseMover());
        addKeyListener(new KeyClicker());
        drawOval = false;
        drawContour = false;
        getImageValues();
        snake = new Snake(imageValues, width, height);
        setBounds(0, 0, width, height);
        parent.validate();
        parent.repaint();
    }

    private void iterateSnake(int nbd, int maxIterations)
    {
        int i = 0;
        do
        {
            if(i >= maxIterations)
                break;
            ptsMoved = snake.moveSnake(nbd);

			// Now the snake has moved, try to store the current status
			// But avoid damn aliasing problems!!!
			Contour c = snake.getContour();		// c is the current state of the contour
			Contour temp = new Contour();		// This will be my generated copy
			for(int j = 0; j < c.getNumPoints(); j++)
			{
				Point p = c.getPoint(j);
				temp.addPointAtEnd(p.x, p.y);
			}
			contourHistory.addElement(temp);

            if(ptsMoved == 0)
                break;
            i++;
        } while(true);
    }

    public void setCurvatureWeight(double curvWt)
    {
        snake.setCurvatureWeight(curvWt);
        parameterChange = true;
    }

    public void setContinuityWeight(double contWt)
    {
        snake.setContinuityWeight(contWt);
        parameterChange = true;
    }

    public void setGradientWeight(double gradWt)
    {
        snake.setGradientWeight(gradWt);
        parameterChange = true;
    }

    public void setCurveBehavior(int curvBehav)
    {
        snake.setCurveBehavior(curvBehav);
        parameterChange = true;
    }

	public void setPointSpacing(double pSp)
	{
		pointSpacing = pSp;
		parameterChange = true;
	}

    public void update(Graphics g)
    {
        paint(g);
    }

    private synchronized void getImageValues()
    {
        width = image.getWidth(this);
        height = image.getHeight(this);
        int pixels[] = new int[width * height];
        PixelGrabber pixGrabber = new PixelGrabber(image, 0, 0, width, height, pixels, 0, width);
        try
        {
            pixGrabber.grabPixels();
        }
        catch(InterruptedException e)
        {
            System.out.println("exception thrown");
        }
        imageValues = new int[width][height];
        for(int y = 0; y < height; y++)
        {
            for(int x = 0; x < width; x++)
                imageValues[x][y] = pixels[y * width + x] & 0xff;

        }

    }

    public void paint(Graphics g)
    {
        g.drawImage(image, 0, 0, this);
        if(drawOval)
        {
            int iX = initX;
            int iY = initY;
            if(ovalWidth < 0)
            {
                iX += ovalWidth;
                ovalWidth = -ovalWidth;
            }
            if(ovalHeight < 0)
            {
                iY += ovalHeight;
                ovalHeight = -ovalHeight;
            }
            g.setColor(Color.red);
            g.drawOval(iX, iY, ovalWidth, ovalHeight);
        }
        if(drawContour)
        {
            g.setColor(Color.yellow);
            g.drawPolygon(contour);
            int numPts = contour.getNumPoints();
            Point pt = contour.getPoint(numPts - 1);
            Point pt2 = contour.getPoint(0);
            g.drawLine(pt.x, pt.y, pt2.x, pt2.y);	// This is the circle

			// These are the final points
            if(ptsMoved != 0)
                g.setColor(Color.green);
            else
                g.setColor(Color.red);
            for(int i = 0; i < numPts; i++)
			{
				int boxSize = 2;
             	g.drawLine(((Polygon) (contour)).xpoints[i]-boxSize, ((Polygon) (contour)).ypoints[i]+boxSize, ((Polygon) (contour)).xpoints[i]+boxSize, ((Polygon) (contour)).ypoints[i]+boxSize);	// TOP
				g.drawLine(((Polygon) (contour)).xpoints[i]-boxSize, ((Polygon) (contour)).ypoints[i]-boxSize, ((Polygon) (contour)).xpoints[i]+boxSize, ((Polygon) (contour)).ypoints[i]-boxSize);	// BOTTOM
				g.drawLine(((Polygon) (contour)).xpoints[i]-boxSize, ((Polygon) (contour)).ypoints[i]-boxSize, ((Polygon) (contour)).xpoints[i]-boxSize, ((Polygon) (contour)).ypoints[i]+boxSize);	// LEFT
				g.drawLine(((Polygon) (contour)).xpoints[i]+boxSize, ((Polygon) (contour)).ypoints[i]-boxSize, ((Polygon) (contour)).xpoints[i]+boxSize, ((Polygon) (contour)).ypoints[i]+boxSize);	// RIGHT				
			}

			// Draw the contour history (the snakes themselves)
			int size = contourHistory.size();
			for(int i = 0; i < numPts; i++)		// For each point in the contour
			{
				for(int j = 0; j < size - 1; j++)	// For each history (except last one as we will use j and j+1)
				{
					Contour a = (Contour)contourHistory.elementAt(j);
					Contour b = (Contour)contourHistory.elementAt(j+1);

					Point pA = a.getPoint(i);
					Point pB = b.getPoint(i);

					g.drawLine(pA.x, pA.y, pB.x, pB.y);
					// System.out.println("size = " + size + " (" + pA.x + "," + pA.y + ")-(" + pB.x + "," + pB.y + ")");
				}
			}

        }
    }

    private Image image;
    boolean trueSizeKnown;
    Dimension minSize;
    int w;
    int h;
    private int imageValues[][];
    private int width;
    private int height;
    private int initX;
    private int initY;
    private int ovalWidth;
    private int ovalHeight;
    private int ptsMoved;
    private boolean drawOval;
    private boolean drawContour;
    private boolean mouseDn;
    private boolean parameterChange;
    private boolean contourInit;
    private Snake snake;
    private Contour contour;

	private Vector contourHistory = new Vector();
	private double pointSpacing = 10D;

}
