// Decompiled by Jad v1.5.8f. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Snake.java

import java.awt.Point;

public class Snake
{

    public Snake(int imageVals[][], int w, int h)
    {
        contour = new Contour();
        width = w;
        height = h;
        imageValues = new int[width][height];
        for(int y = 0; y < height; y++)
        {
            for(int x = 0; x < width; x++)
                imageValues[x][y] = imageVals[x][y];

        }

        computeGradientImage();
        curvatureWeight = 1.0D;
        continuityWeight = 1.0D;
        gradientWeight = 1.2D;
        curveBehavior = 0;
    }

    public boolean getContourFromOval(int initX, int initY, int ovalWidth, int ovalHeight, double pointSpacing)
    {
        double xAxis = (double)ovalWidth / (double)2;
        double yAxis = (double)ovalHeight / (double)2;
        double approxPerim = 6.2831853071795862D * Math.sqrt((xAxis * xAxis + yAxis * yAxis) / (double)2);
        double xCenter = (double)initX + xAxis;
        double yCenter = (double)initY + yAxis;
        int numContourPts = (int)Math.round(approxPerim / pointSpacing);
        double angleStep = 6.2831853071795862D / (double)numContourPts;
        double angle = 0.0D;
        if(contour.getNumPoints() > 0)
            contour = new Contour();
        boolean enoughPoints = numContourPts > 4;
        if(enoughPoints)
        {
            for(int i = 0; i < numContourPts; i++)
            {
                int x = (int)Math.round(xAxis * Math.cos(angle) + xCenter);
                int y = (int)Math.round(yAxis * Math.sin(angle) + yCenter);
                contour.addPointAtEnd(x, y);
                angle += angleStep;
            }

        }
        return enoughPoints;
    }

    public int moveSnake(int size)
    {
		System.out.println("TOP cont: " + continuityWeight + " curv: " + curvatureWeight + " grad: " + gradientWeight);

        int halfSize = (size - 1) / 2;
        int numPts = contour.getNumPoints();
        int ptsMoved = 0;
        if(numPts < 5)
            return 0;
        Point testPoint = new Point(0, 0);
        double contArray[][] = new double[size][size];
        double curvArray[][] = new double[size][size];
        double gradArray[][] = new double[size][size];
        contour.removeDuplicates();
        for(int i = 0; i < numPts; i++)
        {
            double maxCont = -1D;
            double maxCurv = -1D;
            double maxGrad = -1D;
            double minGrad = (1.0D / 0.0D);
            double minEnergy = (1.0D / 0.0D);
            Point tempPoint = contour.getPoint(i);
            int ptX = tempPoint.x;
            int ptY = tempPoint.y;
            int xMin = ptX - halfSize;
            if(xMin < 1)
                xMin = 1;
            int xMax = ptX + halfSize;
            if(xMax > width - 2)
                xMax = width - 2;
            int yMin = ptY - halfSize;
            if(yMin < 1)
                yMin = 1;
            int yMax = ptY + halfSize;
            if(yMax > height - 2)
                yMax = height - 2;
            for(int y = yMin; y <= yMax; y++)
            {
                for(int x = xMin; x <= xMax; x++)
                {
                    testPoint.move(x, y);
                    double tempCont = computeContinuity(i, testPoint);
                    double tempCurv = computeCurvature(i, testPoint);
                    double tempGrad = gradientValues[x][y];
                    contArray[x - xMin][y - yMin] = tempCont;
                    curvArray[x - xMin][y - yMin] = tempCurv;
                    gradArray[x - xMin][y - yMin] = tempGrad;
                    if(tempCont > maxCont)
                        maxCont = tempCont;
                    if(tempCurv > maxCurv)
                        maxCurv = tempCurv;
                    if(tempGrad > maxGrad)
                        maxGrad = tempGrad;
                    if(tempGrad < minGrad)
                        minGrad = tempGrad;
                }

            }

            double diffGrad = maxGrad - minGrad;
            if(diffGrad < 1.0D)
                diffGrad = 1.0D;
            Point newPoint = new Point(0, 0);
            double centerEnergy = (1.0D / 0.0D);
            for(int y = yMin; y <= yMax; y++)
            {
                for(int x = xMin; x <= xMax; x++)
                {
                    double energy = (continuityWeight * contArray[x - xMin][y - yMin]) / maxCont + (curvatureWeight * curvArray[x - xMin][y - yMin]) / maxCurv + (gradientWeight * (minGrad - gradArray[x - xMin][y - yMin])) / diffGrad;
                    if(energy < minEnergy)
                    {
                        newPoint.move(x, y);
                        minEnergy = energy;
                    }
                    if(x == ptX && y == ptY)
                        centerEnergy = energy;
                }

            }

            if(!newPoint.equals(tempPoint) && minEnergy < centerEnergy)
            {
                contour.changePoint(i, newPoint);
                ptsMoved++;
            }
        }

        return ptsMoved;
    }

    private double computeContinuity(int index, Point testPoint)
    {
        Point prevPoint = contour.getPoint(index - 1);
        double xTerm = testPoint.x - prevPoint.x;
        double yTerm = testPoint.y - prevPoint.y;
        double contEnergy;
        switch(curveBehavior)
        {
        case 1: // '\001'
            contEnergy = Math.abs(contour.avgDist() - Math.sqrt(xTerm * xTerm + yTerm * yTerm));
            break;

        case 0: // '\0'
        default:
            contEnergy = xTerm * xTerm + yTerm * yTerm;
            break;
        }
        return contEnergy;
    }

    private double computeCurvature(int index, Point testPoint)
    {
        Point prevPoint = contour.getPoint(index - 1);
        Point nextPoint = contour.getPoint(index + 1);
        double xTerm = (prevPoint.x - 2 * testPoint.x) + nextPoint.x;
        double yTerm = (prevPoint.y - 2 * testPoint.y) + nextPoint.y;
        double curvEnergy = xTerm * xTerm + yTerm * yTerm;
        return curvEnergy;
    }

    private void computeGradientImage()
    {
        gradientValues = new double[width][height];
        for(int y = 1; y < height - 1; y++)
        {
            for(int x = 1; x < width - 1; x++)
            {
                int h1 = imageValues[x - 1][y - 1] + 2 * imageValues[x][y - 1] + imageValues[x + 1][y - 1];
                int h2 = imageValues[x - 1][y + 1] + 2 * imageValues[x][y + 1] + imageValues[x + 1][y + 1];
                int h = h2 - h1;
                int v1 = imageValues[x - 1][y - 1] + 2 * imageValues[x - 1][y] + imageValues[x - 1][y + 1];
                int v2 = imageValues[x + 1][y - 1] + 2 * imageValues[x + 1][y] + imageValues[x + 1][y + 1];
                int v = v2 - v1;
                gradientValues[x][y] = Math.sqrt(h * h + v * v);
            }

        }

    }

    public Contour getContour()
    {
        return contour;
    }

    public void setCurvatureWeight(double curvWt)
    {
		System.out.println("setCurvatureWeight: " + curvWt);
        curvatureWeight = curvWt;
    }

    public void setContinuityWeight(double contWt)
    {
		System.out.println("setContinuityWeight: " + contWt);
        continuityWeight = contWt;
    }

    public void setGradientWeight(double gradWt)
    {
		System.out.println("setGradientWeight: " + gradWt);
        gradientWeight = gradWt;
    }

    public void setCurveBehavior(int curvBehav)
    {
        curveBehavior = curvBehav;
    }

    public static final int SHRINK = 0;
    public static final int NO_SHRINK = 1;
    private Contour contour;
    private int imageValues[][];
    private double gradientValues[][];
    private int width;
    private int height;
    private double curvatureWeight;
    private double continuityWeight;
    private double gradientWeight;
    private int curveBehavior;

}
